searchNodes=[{"doc":"Interface with tmf8820/tmf8821 direct time-of-flight (dToF) sensor ([ https://ams.com/en/tmf8820] ). Starting Start a TMF882X it directly from another process (See Options section below for more info): { :ok , pid } = TMF882X . start_link ( bus : &quot;i2c-1&quot; ) Configuration A configuration keyword list can be passed to the start_link function containing the following parameters: bus - Name of the I2C bus that the sensor is attached to. interrupt_gpio - If the interrupt pin of the sensor is connected, the GPIO number can be specified here. If not interrupt pin is specified , then the library will use I2C to poll when a new measurement packet is ready . enable_gpio - If the enable pin is connected, the GPIO number can be specified here. If connected, calling reset/1 will use this pin to reset the device . Otherwise , I2C commands will be issued to reset the device . ( default : ` nil ` ) auto_start - If set to true , the device will immediately start taking measurements once the app_ready status is true . If set to ` false ` , the device will wait for a call to ` start_measuring / 1 ` before taking any measurements . ( default : ` true ` ) measure_interval - Target interval (in milliseconds) between measurements. If set to 0 , as soon as a measurement is received, another will start . device_config - The configuration to be sent to the device on startup. See Configuration section below. Results The calling process will receive messages of the format {:tmf882x, %TMF882X.Result{}} : def handle_info ( { :tmf882x , % TMF882X.Result { } = result } ) do ... end The TMF882X.Result struct contains a list of measurements from each channel. Each measurement is a tuple containing a distance (in millimeters) and confidence (out of 255) value: % TMF882X.Result { tid : 200 , size : 128 , number : 200 , temperature : 41 , valid_results : 11 , ambient : 283 , photon_count : 16971 , reference_count : 60573 , sys_tick : 1215866837 , measurements : [ { 844 , 61 } , { 841 , 106 } , { 1010 , 56 } , ... ] } Other fields in the Result struct are directly from the decode of the Result register.","ref":"TMF882X.html","title":"TMF882X","type":"module"},{"doc":"Returns true if the application on the device has been initialized. Measurements cannot be started until the app_ready flag is true .","ref":"TMF882X.html#app_ready?/1","title":"TMF882X.app_ready?/1","type":"function"},{"doc":"","ref":"TMF882X.html#calc_measure_delay/1","title":"TMF882X.calc_measure_delay/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"TMF882X.html#child_spec/1","title":"TMF882X.child_spec/1","type":"function"},{"doc":"Queries the device for its current configuration and returns it.","ref":"TMF882X.html#get_config/1","title":"TMF882X.get_config/1","type":"function"},{"doc":"Queries the device for the current custom spad_map and returns it.","ref":"TMF882X.html#get_custom_spad/1","title":"TMF882X.get_custom_spad/1","type":"function"},{"doc":"Returns the status of the device gathered from the 0xE0 register.","ref":"TMF882X.html#get_status/1","title":"TMF882X.get_status/1","type":"function"},{"doc":"Applies the given configuration values to the device. This will temporarily stop the measurements and resume them after the configuration if written (if they were running before).","ref":"TMF882X.html#put_config/2","title":"TMF882X.put_config/2","type":"function"},{"doc":"Resets the device including resetting the enable pin (if configured).","ref":"TMF882X.html#reset/1","title":"TMF882X.reset/1","type":"function"},{"doc":"Returns true if the process is measuring actively.","ref":"TMF882X.html#running?/1","title":"TMF882X.running?/1","type":"function"},{"doc":"Sets the custom spad to the one provided. NOTE: the device configuration must be set with spad_map_id set to 14 before the custom spad map can be written. Otherwise, the custom spad command will silently fail.","ref":"TMF882X.html#set_custom_spad/2","title":"TMF882X.set_custom_spad/2","type":"function"},{"doc":"","ref":"TMF882X.html#start_link/1","title":"TMF882X.start_link/1","type":"function"},{"doc":"Starts the measurement process for the given device. Once started, the process will send {:tmf882x, %TMF882X.Result{}} messages each time a measurement is completed.","ref":"TMF882X.html#start_measuring/1","title":"TMF882X.start_measuring/1","type":"function"},{"doc":"Stops the measurement process for the given device.","ref":"TMF882X.html#stop_measuring/1","title":"TMF882X.stop_measuring/1","type":"function"},{"doc":"","ref":"TMF882X.html#t:server/0","title":"TMF882X.server/0","type":"type"},{"doc":"Module for managing the bootloader interaction. Each time the TMF882X is started, the measurement application must be written to its memory. The actual application is encoded in TMF882X.Firmware.image/0) .","ref":"TMF882X.Boot.html","title":"TMF882X.Boot","type":"module"},{"doc":"Loads the app from TMF882X.Firmware.image/0 onto the device and starts it.","ref":"TMF882X.Boot.html#load_app/1","title":"TMF882X.Boot.load_app/1","type":"function"},{"doc":"Checks to see if the device is currently running the bootloader and, if so, writes the measurement application to firmware and starts it.","ref":"TMF882X.Boot.html#load_app_if_in_bootloader/1","title":"TMF882X.Boot.load_app_if_in_bootloader/1","type":"function"},{"doc":"Module for interfacing with the TMF882X over I2C. This module handles the lower-level communication with the device.","ref":"TMF882X.Bus.html","title":"TMF882X.Bus","type":"module"},{"doc":"Reads a number of bytes from the bus","ref":"TMF882X.Bus.html#read/2","title":"TMF882X.Bus.read/2","type":"function"},{"doc":"Waits for the device to be present on the I2C bus and returns :ok when it is found, or {:error, :i2c_device_timeout} if the device is not found before the given timeout (in ms).","ref":"TMF882X.Bus.html#wait_for_device/2","title":"TMF882X.Bus.wait_for_device/2","type":"function"},{"doc":"Waits for the i2c bus to become available and connects to it. Returns {:ok, pid} when successful or {:error, :i2c_timeout} if not bus connection was made before the given timeout","ref":"TMF882X.Bus.html#wait_for_i2c_and_connect/2","title":"TMF882X.Bus.wait_for_i2c_and_connect/2","type":"function"},{"doc":"Writes data to the bus.","ref":"TMF882X.Bus.html#write/2","title":"TMF882X.Bus.write/2","type":"function"},{"doc":"Writes the given data to the bus then immediately reads the given number of bytes off of the bus.","ref":"TMF882X.Bus.html#write_read/3","title":"TMF882X.Bus.write_read/3","type":"function"},{"doc":"Handles translation to and from configuration registers.","ref":"TMF882X.Config.html","title":"TMF882X.Config","type":"module"},{"doc":"Creates a command to set the measurement period","ref":"TMF882X.Config.html#cmd_period/1","title":"TMF882X.Config.cmd_period/1","type":"function"},{"doc":"Creates a command to set the spad_map_id","ref":"TMF882X.Config.html#cmd_spad_map_id/1","title":"TMF882X.Config.cmd_spad_map_id/1","type":"function"},{"doc":"Creates a new Config from the config register page. The expected registers start at the &lt;&lt;0x16&gt;&gt; expected in register 0x20 .","ref":"TMF882X.Config.html#new/1","title":"TMF882X.Config.new/1","type":"function"},{"doc":"","ref":"TMF882X.Config.html#t:alg_setting/0","title":"TMF882X.Config.alg_setting/0","type":"type"},{"doc":"","ref":"TMF882X.Config.html#t:gpio_config/0","title":"TMF882X.Config.gpio_config/0","type":"type"},{"doc":"","ref":"TMF882X.Config.html#t:power_cfg/0","title":"TMF882X.Config.power_cfg/0","type":"type"},{"doc":"","ref":"TMF882X.Config.html#t:t/0","title":"TMF882X.Config.t/0","type":"type"},{"doc":"Handles communication around device setup and configuration.","ref":"TMF882X.Device.html","title":"TMF882X.Device","type":"module"},{"doc":"Applies a subset of configuration","ref":"TMF882X.Device.html#apply_config/2","title":"TMF882X.Device.apply_config/2","type":"function"},{"doc":"Enables the device via I2C when the enable pin is not connected.","ref":"TMF882X.Device.html#enable/1","title":"TMF882X.Device.enable/1","type":"function"},{"doc":"Returns firmware information for the device.","ref":"TMF882X.Device.html#firmware/1","title":"TMF882X.Device.firmware/1","type":"function"},{"doc":"Returns the SPAD currently in the custom page.","ref":"TMF882X.Device.html#get_custom_spad/1","title":"TMF882X.Device.get_custom_spad/1","type":"function"},{"doc":"Read the contents of the configuration page register and returns them as a TMF882X.Config struct.","ref":"TMF882X.Device.html#read_config/1","title":"TMF882X.Device.read_config/1","type":"function"},{"doc":"Sets the spad in the custom spad page to the provided one.","ref":"TMF882X.Device.html#set_custom_spad/2","title":"TMF882X.Device.set_custom_spad/2","type":"function"},{"doc":"Returns the status of the device gathered from the 0xE0 register","ref":"TMF882X.Device.html#status/1","title":"TMF882X.Device.status/1","type":"function"},{"doc":"Waits until the STAT_OK register returns a value less than 0x10 and returns :ok or returns {:error, :wait_timeout} if it does not before the given timeout (in ms).","ref":"TMF882X.Device.html#wait/2","title":"TMF882X.Device.wait/2","type":"function"},{"doc":"Waits until the status of the device returns as enabled. Ether returns :ok if the device becomes enabled or {:ok, :enable_timeout} if the device is not enabled before the timeout.","ref":"TMF882X.Device.html#wait_for_enabled/2","title":"TMF882X.Device.wait_for_enabled/2","type":"function"},{"doc":"Waits until the STAT_OK register returns a value of 0x00 and returns :ok or returns {:error, :wait_timeout} if it does not before the given timeout (in ms).","ref":"TMF882X.Device.html#wait_for_stat_ok/2","title":"TMF882X.Device.wait_for_stat_ok/2","type":"function"},{"doc":"Contains the binary image for the measurement application that must be loaded onto the TMF882X on each startup. This image is taken from [ https://github.com/sparkfun/SparkFun_Qwiic_TMF882X_Arduino_Library/blob/main/src/tof_bin_image.c]","ref":"TMF882X.Firmware.html","title":"TMF882X.Firmware","type":"module"},{"doc":"","ref":"TMF882X.Firmware.html#image/0","title":"TMF882X.Firmware.image/0","type":"function"},{"doc":"Manages the starting and stopping of the measurement process.","ref":"TMF882X.Measure.html","title":"TMF882X.Measure","type":"module"},{"doc":"Clears the interrupt register","ref":"TMF882X.Measure.html#clear_interrupts/1","title":"TMF882X.Measure.clear_interrupts/1","type":"function"},{"doc":"Enables the interrupt register","ref":"TMF882X.Measure.html#enable_interrupt/1","title":"TMF882X.Measure.enable_interrupt/1","type":"function"},{"doc":"Reads the data in the measurement registry and returns the decoded TMF882X.Result struct.","ref":"TMF882X.Measure.html#read_data/1","title":"TMF882X.Measure.read_data/1","type":"function"},{"doc":"Starts a measurement","ref":"TMF882X.Measure.html#start/1","title":"TMF882X.Measure.start/1","type":"function"},{"doc":"Stops a measurement in progress","ref":"TMF882X.Measure.html#stop/1","title":"TMF882X.Measure.stop/1","type":"function"},{"doc":"Waits for interrupt bit to be set. Useful when the interrupt pin is not used.","ref":"TMF882X.Measure.html#wait_for_interrupt/2","title":"TMF882X.Measure.wait_for_interrupt/2","type":"function"},{"doc":"Encodes and decodes the contents of the measurement register.","ref":"TMF882X.Result.html","title":"TMF882X.Result","type":"module"},{"doc":"Creates a new Result from the contents of the result register (0x20). This assumes the binary starts with at 0x20 and includes the cid_rid value of 0x10 .","ref":"TMF882X.Result.html#new/1","title":"TMF882X.Result.new/1","type":"function"},{"doc":"","ref":"TMF882X.Result.html#t:t/0","title":"TMF882X.Result.t/0","type":"type"},{"doc":"Utilities for working with messages from the TMF882X","ref":"TMF882X.Util.html","title":"TMF882X.Util","type":"module"},{"doc":"Returns true if a given bit position set, false otherwise.","ref":"TMF882X.Util.html#bit_set?/2","title":"TMF882X.Util.bit_set?/2","type":"function"},{"doc":"Encodes an integer as a single byte binary","ref":"TMF882X.Util.html#encode_int_1/1","title":"TMF882X.Util.encode_int_1/1","type":"function"},{"doc":"Encodes an integer as a 2-byte binary","ref":"TMF882X.Util.html#encode_int_2/1","title":"TMF882X.Util.encode_int_2/1","type":"function"},{"doc":"Encodes an integer as a 3-byte binary","ref":"TMF882X.Util.html#encode_int_3/1","title":"TMF882X.Util.encode_int_3/1","type":"function"},{"doc":"Encodes an integer as a 4-byte binary","ref":"TMF882X.Util.html#encode_int_4/1","title":"TMF882X.Util.encode_int_4/1","type":"function"},{"doc":"Returns the first byte of the binary","ref":"TMF882X.Util.html#extract_int_1/1","title":"TMF882X.Util.extract_int_1/1","type":"function"},{"doc":"Returns the integer represented by the byte of the binary at position address if the first byte of the binary is at position start .","ref":"TMF882X.Util.html#extract_int_1_at/3","title":"TMF882X.Util.extract_int_1_at/3","type":"function"},{"doc":"Returns the integer represented by the first two bytes of the binary","ref":"TMF882X.Util.html#extract_int_2/1","title":"TMF882X.Util.extract_int_2/1","type":"function"},{"doc":"Returns the integer represented by the two bytes of the binary at position address if the first byte of the binary is at position start .","ref":"TMF882X.Util.html#extract_int_2_at/3","title":"TMF882X.Util.extract_int_2_at/3","type":"function"},{"doc":"Returns the integer represented by the first three bytes of the binary","ref":"TMF882X.Util.html#extract_int_3/1","title":"TMF882X.Util.extract_int_3/1","type":"function"},{"doc":"Returns the integer represented by the three bytes of the binary at position address if the first byte of the binary is at position start .","ref":"TMF882X.Util.html#extract_int_3_at/3","title":"TMF882X.Util.extract_int_3_at/3","type":"function"},{"doc":"Returns the integer represented by the first four bytes of the binary","ref":"TMF882X.Util.html#extract_int_4/1","title":"TMF882X.Util.extract_int_4/1","type":"function"},{"doc":"Returns the integer represented by the four bytes of the binary at position address if the first byte of the binary is at position start .","ref":"TMF882X.Util.html#extract_int_4_at/3","title":"TMF882X.Util.extract_int_4_at/3","type":"function"},{"doc":"Returns an array of integer extracted three bytes at a time until either count integers are found or the end of the binary is reached.","ref":"TMF882X.Util.html#extract_multi_int_3/4","title":"TMF882X.Util.extract_multi_int_3/4","type":"function"},{"doc":"Returns an array of integer extracted four bytes at a time until either count integers are found or the end of the binary is reached.","ref":"TMF882X.Util.html#extract_multi_int_4/4","title":"TMF882X.Util.extract_multi_int_4/4","type":"function"}]